
/*
 *  Implementation of Motor control task
 */

#include "./global.h"
#include "../msp_blimp/_lib_system.h"
#include "./ctl_motor_control_task.h"

static void updateMotorState (MOTOR_STAT *mot, uint8_t dir, uint8_t dc ){
	mot->direction = dir;
	mot->duty_cyle = dc;
}

void ctl_moto_SetMotor (void) {
	// get the values
	uint8_t id = cmd.arg[0];
	uint8_t dir = cmd.arg[1];
	uint8_t duty_cycle = cmd.arg[2];
	// check and call the appropriate function for h
	switch (id){
	case CMD_MOT_ID0 /*Left */:  /*CODE */
		if (dir == CMD_MOT_DIR_FWD)
			sys_LMotor_forward (duty_cycle);
		else if (dir == CMD_MOT_DIR_REV)
			sys_LMotor_reverse (duty_cycle);
		updateMotorState (&ctl_motor_left, dir, duty_cycle);
		break;
	case CMD_MOT_ID1/* Right*/: /*CODE*: */
		if (dir == CMD_MOT_DIR_FWD)
			sys_RMotor_forward (duty_cycle);
		else if (dir == CMD_MOT_DIR_REV)
			sys_RMotor_reverse (duty_cycle);
		updateMotorState (&ctl_motor_right, dir, duty_cycle);
		break;
	case CMD_MOT_ID2/*Vertical*/: /*CODE*: */
		// set pwm and direction for the vertical
		if (dir == CMD_MOT_DIR_UP)
			sys_VMotor_forward (duty_cycle);
		else if (dir == CMD_MOT_DIR_DOWN)
			sys_VMotor_reverse (duty_cycle);
		updateMotorState (&ctl_motor_vertical, dir, duty_cycle);
		break;
	default: break;
	}

}


void ctl_moto_PidSetVMotor (uint8_t duty_cycle, uint8_t dir){
	// set pwm and direction for the vertical
	if (dir == CMD_MOT_DIR_UP)
		sys_VMotor_forward (duty_cycle);
	else if (dir == CMD_MOT_DIR_DOWN)
		sys_VMotor_reverse (duty_cycle);
	updateMotorState (&ctl_motor_vertical, dir, duty_cycle);
}


void ctl_moto_SetLeftMotor (uint8_t duty_cycle, uint8_t dir){
	if (dir == CMD_MOT_DIR_FWD)
		sys_LMotor_forward (duty_cycle);
	else if (dir == CMD_MOT_DIR_REV)
		sys_LMotor_reverse (duty_cycle);
	updateMotorState (&ctl_motor_left, dir, duty_cycle);
}


void ctl_moto_SetRightMotor (uint8_t duty_cycle, uint8_t dir){
	if (dir == CMD_MOT_DIR_FWD)
		sys_RMotor_forward (duty_cycle);
	else if (dir == CMD_MOT_DIR_REV)
		sys_RMotor_reverse (duty_cycle);
	updateMotorState (&ctl_motor_right, dir, duty_cycle);
}


void ctl_moto_GoForward (void){
	ctl_moto_SetLeftMotor (80, CMD_MOT_DIR_FWD);
	ctl_moto_SetRightMotor (80, CMD_MOT_DIR_FWD);

}

void ctl_moto_GoBackward(void){
	ctl_moto_SetLeftMotor (100, CMD_MOT_DIR_REV);
	ctl_moto_SetRightMotor (100, CMD_MOT_DIR_REV);
};



