
/*
 * This module used to control the motor of the system
 */

#ifndef _CTL_MOTOR_TASK_
#define _CTL_MOTOR_TASK_
#include "./global.h"

// command struct which cotains command args
extern CMD_COMMAND_FRAME cmd;

// these struct hold the status information of each motors
extern MOTOR_STAT ctl_motor_left;
extern MOTOR_STAT ctl_motor_right;
extern MOTOR_STAT ctl_motor_vertical;
extern uint8_t pid_enable;
extern int pid_counter;

// this function used to set speed and direction or effective thrust of the motors
// also update the status of the struct hold the staus of each motor
void ctl_moto_SetMotor (void);

// this function used to drive motors back to 
// the initialization state where all are drive high
void ctl_moto_toSafeMode (void);

void ctl_moto_PidSetVMotor (uint8_t duty_cycle, uint8_t dir);

void ctl_moto_SetLeftMotor (uint8_t duty_cycle, uint8_t dir);

void ctl_moto_SetRightMotor (uint8_t duty_cycle, uint8_t dir);

void ctl_moto_GoForward (void);

void ctl_moto_GoBackward(void);
#endif // _CTL_MOTOR_TASK
