/*
 * This module is used to store all the global variable which 
 * represents state or status of the Blimp
 */


#ifndef _CTL_GLOBAL_H_
#define _CTL_GLOBAL_H_
#include "../utils/blimp_commands.h"

#define RUNNING 1
#define STOP 0
#define AUTO 2
#define CONNECTED 1
#define DISCONNECTED 0

/*--------------motor_control_task----------------------------*/
#define MOTOR_MAX 255
#define MOTOR_MIN (-255)
#define MOTOR_LEFT '0'
#define MOTOR_RIGHT '1'
#define MOTOR_VERT '2'
#define FORWARD '>'
#define REVERSE '<'

// this struct is used to hold the status of the motor
typedef struct mot_stat {
  uint8_t id; // 0: left, 1:right, 2: vertical
  uint8_t direction; // forward or reverse
  uint8_t duty_cyle; // [0-255]
} MOTOR_STAT;

/*--------------sensing_task----------------------------*/
// 0 -> forward
// 1 -> reverse
// 2 -> right
// 3 -> left
// 4 -> down
#define FORWARD_SENSOR 0
#define REVERSE_SENSOR 1
#define RIGHT_SENSOR 2
#define LEFT_SENSOR 3
#define DOWN_SENSOR 4

#define NOT_TURNING 0
#define TURNING_LEFT 1
#define TURNING_RIGHT 2

#define FACING_OBJECT 0
#define NOT_FACING_OBJECT 1

/*-------------motion_control_task----------------------------*/
//typedef struct pid_st{
//  int K_p;
//  int K_i;
//  int K_d;
//  uint8_t SetPoint;
//  uint8_t DeadBand;
//} PID_INFO;

typedef struct pid {
  float Kp;
  float Ki;
  float Kd;
  unsigned int target_value;
  unsigned int sensor_old;
  unsigned int sensor_new;
  int error;
  int delta_sensor;
  int integral_sum;
} PID_INFO;

// this struct used to store the current values of the pid controller

/*============================GENERAL UTILITIES====================*/


#endif //_CTL_GLOBAL_H_
