#ifndef _lib_sensors_h_
#define _lib_sensors_h_

#include <msp430f5510.h>
#include <stdint.h>


// Initializes PINs and ADC10 that
// are needed for doing sensor reading
//
// IMPORTANT: Needs to be called before any other function
//            in this module is called!
void sensor_Initialize();

// Collect samples from IR receiver with IR transmitter
// of direction being turned on.
//
// Direction:
// 0 -> forward
// 1 -> reverse
// 2 -> right
// 3 -> left
// 4 -> down
//
// Return: The value of the sensor
int sensor_IR_poll(uint8_t direction);



#endif
