// Matthew Kraus
//
// queue.h -- an array based circular FIFO queue, optimized for embedded systems
//
// module prefix: queue_
// 
#pragma once

#ifndef QUEUE_INCLUDED
#define QUEUE_INCLUDED

#ifndef INCLUDED_MSP430_DATATYPES
	#include "msp430_datatypes.h"
#endif

//typedef unsigned char QUEUE_DATATYPE;
typedef char QUEUE_DATATYPE;

typedef struct QUEUE_DATA_
{
	QUEUE_DATATYPE* circularBuffer;
	uint8_t size;
	uint8_t head;
	uint8_t tail;	
	uint8_t numElementsInQueue;
} QUEUE_DATA, *PQUEUE_DATA;


//
// PROTOTYPES /////////////////////////////////////////////////////////////////
//
void queue_create(PQUEUE_DATA queueData, QUEUE_DATATYPE* buffer, uint8_t sizeOfBuffer);

BOOL queue_isEmpty(PQUEUE_DATA queueData);
BOOL queue_isFull(PQUEUE_DATA queueData);

BOOL queue_push(PQUEUE_DATA queueData, QUEUE_DATATYPE val);
BOOL queue_pop(PQUEUE_DATA queueData, QUEUE_DATATYPE* retVal);

BOOL queue_startsWith(PQUEUE_DATA queueData, QUEUE_DATATYPE* values);
BOOL queue_contains(PQUEUE_DATA queueData, QUEUE_DATATYPE val);

BOOL queue_peekAt(PQUEUE_DATA queueData, uint8_t idx, QUEUE_DATATYPE* retVal);

#endif
