//
// uart_to_wci.c
//
// The single purpose of this module is to copy uart data
// coming into the blimp in a safe way. The uart buffer is
// simply copied to the Wireless Control Interface (wci) buffer.
// This copy *must* be synchronized, i.e. all ISRs must be disabled
// during the copy.
// 

#include "../utils/queue.h"

extern QUEUE_DATA wci_RXBUFFER;   // defined in wifi_ctrl_iface.c

void uart_to_wci_copy(QUEUE_DATATYPE val)
{
	if (queue_isFull(&wci_RXBUFFER)) return; // can't hold any more data
		
	// TODO: ENTER CRITICAL SECTION (disable ISRs)		        
	{
		// copy uart data
		queue_push(&wci_RXBUFFER, val);
	}
	// TODO: LEAVE CRITICAL SECTION (enable ISRs)

} // end net_to_wci_copy()
