// Matthew Kraus
// wifi_ctrl_iface.h -- wireless control interface
// module prefix: wci_

#pragma once

#ifndef WIFI_CTRL_IFACE
#define WIFI_CTRL_IFACE

#ifndef INCLUDED_MSP430_DATATYPES
	#include "../utils/msp430_datatypes.h"
#endif

#ifndef INCLUDED_BLIMP_COMMANDS
	#include "../utils/blimp_commands.h"
#endif


/** wci_hasNext()
  *
  * Returns true if a command frame is ready. If a command frame is not already
  * ready, then it tries to process new data to prepare a full command frame.
  * If a full command frame can be formed, the command frame is prepared and
  * true is returned. The new command frame can be retrieved by calling
  * wci_nextCommand().
  */
BOOL wci_hasNext();


/** wci_nextCommand()
  *
  * You *must* call wci_hasNext() and make sure TRUE is returned before calling
  * this method. Failure to check will result in an invalid command frame.
  */
void wci_nextCommand(CMD_COMMAND_FRAME* cf);

#endif // WIFI_CTRL_IFACE